// =========================================================================
//
// Srings.js - String helper library for XML for <SCRIPT>
//
// version 2.1
//
// =========================================================================
//
// Copyright (C) 2002, 2003 David Joham (djoham@yahoo.com) and Scott Severtson
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// visit the XML for <SCRIPT> home page at xmljs.sourceforge.net
//


Strings = new Object()
Strings.WHITESPACE = " \t\n\r";
Strings.QUOTES = "\"'";

Strings.isEmpty = function(strD) {
    return (strD == null) || (strD.length == 0);
};
Strings.indexOfNonWhitespace = function(strD, iB, iE) {
	if(Strings.isEmpty(strD)) return -1;
	iB = iB || 0;
	iE = iE || strD.length;

	for(var i = iB; i < iE; i++)
		if(Strings.WHITESPACE.indexOf(strD.charAt(i)) == -1) {
			return i;
		}
	return -1;
};
Strings.lastIndexOfNonWhitespace = function(strD, iB, iE) {
	if(Strings.isEmpty(strD)) return -1;
	iB = iB || 0;
	iE = iE || strD.length;

	for(var i = iE - 1; i >= iB; i--)
		if(Strings.WHITESPACE.indexOf(strD.charAt(i)) == -1)
			return i;
	return -1;
};
Strings.indexOfWhitespace = function(strD, iB, iE) {
	if(Strings.isEmpty(strD)) return -1;
	iB = iB || 0;
	iE = iE || strD.length;

	for(var i = iB; i < iE; i++)
		if(Strings.WHITESPACE.indexOf(strD.charAt(i)) != -1)
			return i;
	return -1;
};
Strings.replace = function(strD, iB, iE, strF, strR) {
	if(Strings.isEmpty(strD)) return "";
	iB = iB || 0;
	iE = iE || strD.length;

	return strD.substring(iB, iE).split(strF).join(strR);
};
Strings.getLineNumber = function(strD, iP) {
	if(Strings.isEmpty(strD)) return -1;
	iP = iP || strD.length;

	return strD.substring(0, iP).split("\n").length
};
Strings.getColumnNumber = function(strD, iP) {
	if(Strings.isEmpty(strD)) return -1;
	iP = iP || strD.length;

	var arrD = strD.substring(0, iP).split("\n");
	var strLine = arrD[arrD.length - 1];
	arrD.length--;
	var iLinePos = arrD.join("\n").length;

	return iP - iLinePos;
};

StringBuffer=function(){this._a=new Array();};
StringBuffer.prototype.append=function(d){this._a[this._a.length]=d;};
StringBuffer.prototype.toString=function(){return this._a.join("");};


